#ifndef CHIRP_ACL_H
#define CHIRP_ACL_H

#include <stdio.h>

#define CHIRP_ACL_BASE_NAME ".__chirpacl"
#define CHIRP_ACL_BASE_LENGTH (strlen(CHIRP_ACL_BASE_NAME))

#define CHIRP_ACL_READ    1
#define CHIRP_ACL_WRITE   2
#define CHIRP_ACL_LIST    4
#define CHIRP_ACL_ADMIN   8
#define CHIRP_ACL_RESERVE 16
#define CHIRP_ACL_ALL     (~0)

int          chirp_acl_check( const char *filename, const char *subject, int flags );
int          chirp_acl_check_dir( const char *dirname, const char *subject, int flags );

int          chirp_acl_set( const char *filename, const char *subject, int flags );

FILE *       chirp_acl_open( const char *filename );
int          chirp_acl_read( FILE *aclfile, char *subject, int *flags );
void         chirp_acl_close( FILE *aclfile);

const char * chirp_acl_flags_to_text( int flags );
int          chirp_acl_text_to_flags( const char *text );

void         chirp_acl_force_readonly();

int          chirp_acl_init_root( const char *path );
int	     chirp_acl_init_copy( const char *path );
int	     chirp_acl_init_reserve( const char *path, const char *subject );

#endif
