/*
Copyright (C) 2004 Douglas Thain
This work is made available under a BSD-style license.
See the file COPYING for details.
*/

#ifndef HASH_CACHE_H
#define HASH_CACHE_H

#include "hash_table.h"

typedef void (*hash_cache_cleanup_t) ( void *value );

struct hash_cache * hash_cache_create( int size, hash_func_t func, hash_cache_cleanup_t cleanup );
void hash_cache_delete( struct hash_cache *cache );

int hash_cache_insert( struct hash_cache *cache, const char *key, void *value, int lifetime );
void * hash_cache_remove( struct hash_cache *cache, const char *key );
void * hash_cache_lookup( struct hash_cache *cache, const char *key );

typedef int  (*hash_cache_iter_t) ( struct hash_cache *h, char *key, void *value, void *arg );

int hash_cache_iterate( struct hash_cache *h, hash_cache_iter_t iter, void *arg );

#endif

